﻿<HandleError()> _
Public Class HomeController
    Inherits System.Web.Mvc.Controller

    Function Index(ByVal id As Integer?, ByVal page As Integer?) As ActionResult
        ' 画面切り替え時にセッションクリア
        Session("RegisterData") = Nothing
        Session("EditUserInfoData") = Nothing
        Session("EditUserPasswordData") = Nothing
        Session("PasswordChangeData") = Nothing

        Dim connStr As String = Util.GetConnectionString
        Dim dc As WebShoppingDBDataContext = New WebShoppingDBDataContext(connStr)

        Dim model As ProductModel = New ProductModel

        model.Categories = From t In dc.GetTable(Of Categories)() Order By t.SORT_NO Ascending

        If Not id Is Nothing AndAlso id <> 0 Then ' カテゴリから選択したとき
            Dim maxItem As Integer = CInt(Util.GetAppSetting("PageSizeProductList"))
            Dim curPage As Integer = If(page, 0)
            Dim max As Integer = (From t In dc.GetTable(Of Products)() Where t.CATEGORY_ID = id).Count

            model.Products = (From t In dc.GetTable(Of Products)() Where t.CATEGORY_ID = id Order By t.SORT_NO Ascending).Skip(curPage * maxItem).Take(maxItem)

            model.CurrentCategory = id
            model.CurrentPage = curPage

            If curPage = 0 Then
                model.HasPrevPage = False
            Else
                model.HasPrevPage = True
            End If

            If curPage * maxItem + maxItem < max Then
                model.HasNextPage = True
            Else
                model.HasNextPage = False
            End If
            Session("SerachKeyword") = Nothing
        Else ' 検索条件のとき

            If Not Session("SerachKeyword") Is Nothing Then
                Dim maxItem As Integer = CInt(Util.GetAppSetting("PageSizeProductList"))
                Dim curPage As Integer = If(page, 0)
                Dim max As Integer = (From t In dc.GetTable(Of Products)() Where t.PRODUCT_NAME.Contains(Session("SerachKeyword")) OrElse t.PRODUCT_DESCRIPTION.Contains(Session("SerachKeyword"))).Count

                model.Products = (From t In dc.GetTable(Of Products)() Where t.PRODUCT_NAME.Contains(Session("SerachKeyword")) OrElse t.PRODUCT_DESCRIPTION.Contains(Session("SerachKeyword")) Order By t.SORT_NO Ascending).Skip(curPage * maxItem).Take(maxItem)

                model.CurrentCategory = id
                model.CurrentPage = curPage

                If curPage = 0 Then
                    model.HasPrevPage = False
                Else
                    model.HasPrevPage = True
                End If

                If curPage * maxItem + maxItem < max Then
                    model.HasNextPage = True
                Else
                    model.HasNextPage = False
                End If
            End If

        End If

        Return View(model)
    End Function


    <HttpPost()>
    Function Index(ByVal collection As FormCollection) As ActionResult
        If collection.Item("button") = "検索" Then
           

            Dim connStr As String = Util.GetConnectionString
            Dim dc As WebShoppingDBDataContext = New WebShoppingDBDataContext(connStr)

            Dim model As ProductModel = New ProductModel

            model.Categories = From t In dc.GetTable(Of Categories)() Order By t.SORT_NO Ascending

            ViewData("search_value") = collection.Item("search")

            If collection.Item("search").Trim = "" Then
                Return View(model)
            End If

            Dim maxItem As Integer = CInt(Util.GetAppSetting("PageSizeProductList"))
            Dim curPage As Integer = 0
            Dim max As Integer = (From t In dc.GetTable(Of Products)() Where t.PRODUCT_NAME.Contains(collection.Item("search")) OrElse t.PRODUCT_DESCRIPTION.Contains(collection.Item("search"))).Count

            model.Products = (From t In dc.GetTable(Of Products)() Where t.PRODUCT_NAME.Contains(collection.Item("search")) OrElse t.PRODUCT_DESCRIPTION.Contains(collection.Item("search")) Order By t.SORT_NO Ascending).Skip(curPage * maxItem).Take(maxItem)

            Session("SerachKeyword") = collection.Item("search")

            model.CurrentPage = curPage

            If curPage = 0 Then
                model.HasPrevPage = False
            Else
                model.HasPrevPage = True
            End If

            If curPage * maxItem + maxItem < max Then
                model.HasNextPage = True
            Else
                model.HasNextPage = False
            End If

            Return View(model)
        Else
            Return RedirectToAction("Maintenance", "Home")
        End If
    End Function

    Function Detail(ByVal id As Integer) As ActionResult
        Dim connStr As String = Util.GetConnectionString
        Dim dc As WebShoppingDBDataContext = New WebShoppingDBDataContext(connStr)

        Dim model As DetailModel = New DetailModel

        Try
            model = (From t In dc.GetTable(Of Products)() Where t.PRODUCT_ID = id
                  Select New DetailModel With {
                      .ProductID = t.PRODUCT_ID,
                      .ProductName = t.PRODUCT_NAME,
                      .ProductDetail = t.PRODUCT_DESCRIPTION,
                      .Price = t.PRICE}).First
        Catch ex As Exception
            Return RedirectToAction("Maintenance", "Home")
        End Try


        Return View(model)
    End Function

    <HttpPost()>
    Function Detail(ByVal id As Integer, ByVal collection As FormCollection) As ActionResult
        If collection.Item("button") = "カートに入れる" Then
            Dim connStr As String = Util.GetConnectionString
            Dim dc As WebShoppingDBDataContext = New WebShoppingDBDataContext(connStr)
            ' ログイン情報を取得
            Dim acc As AccountInfo = TryCast(Session("AccountInfo"), AccountInfo)

            ' ログイン情報がなければエラー
            If acc Is Nothing Then
                Return RedirectToAction("Maintenance", "Home")
            End If

            ' 該当する商品がなければエラー
            Dim model As DetailModel = New DetailModel

            Try
                model = (From t In dc.GetTable(Of Products)() Where t.PRODUCT_ID = id
                      Select New DetailModel With {
                          .ProductID = t.PRODUCT_ID,
                          .ProductName = t.PRODUCT_NAME,
                          .ProductDetail = t.PRODUCT_DESCRIPTION,
                          .Price = t.PRICE}).First
            Catch ex As Exception
                Return RedirectToAction("Maintenance", "Home")
            End Try

            ' カートに入れる
            Try
                dc.insertAddCart(acc.USER_ID, id, 1)
                dc.SubmitChanges()
            Catch ex As Exception
                Return RedirectToAction("Maintenance", "Home")
            End Try


            Return RedirectToAction("Index", "Cart")
        Else
            Return RedirectToAction("Maintenance", "Home")
        End If
    End Function

    Function Maintenance() As ActionResult
        Session.Clear()
        Return View()
    End Function

    Function About() As ActionResult
        ' 画面切り替え時にセッションクリア
        Session("RegisterData") = Nothing
        Session("EditUserInfoData") = Nothing
        Session("EditUserPasswordData") = Nothing
        Session("PasswordChangeData") = Nothing

        Return View()
    End Function
End Class
