﻿Imports System.ComponentModel
Imports System.ComponentModel.DataAnnotations
Imports System.Globalization

Public Class EditUserInfoModel

    <DisplayName("ユーザID")> _
    Public Property USER_ID As String

    <Required(ErrorMessage:="姓（漢字）は必須項目です")> _
    <StringLength(20, ErrorMessage:="姓（漢字）は20文字以内で入力してください。")>
    <DisplayName("姓（漢字）")> _
    Public Property KANJI_SEI As String

    <Required(ErrorMessage:="名（漢字）は必須項目です")> _
    <StringLength(20, ErrorMessage:="名（漢字）は20文字以内で入力してください。")>
    <DisplayName("名（漢字）")> _
    Public Property KANJI_MEI As String

    <Required(ErrorMessage:="姓（カナ）は必須項目です")> _
    <StringLength(20, ErrorMessage:="姓（カナ）は20文字以内で入力してください。")>
    <RegularExpression("^[ァ-ヶ|ー]+$", ErrorMessage:="姓（カナ）は全角カタカナでご入力ください")>
    <DisplayName("姓（カナ）")> _
    Public Property KANA_SEI As String

    <Required(ErrorMessage:="名（カナ）は必須項目です")> _
    <StringLength(20, ErrorMessage:="名（カナ）は20文字以内で入力してください。")>
    <RegularExpression("^[ァ-ヶ|ー]+$", ErrorMessage:="名（カナ）は全角カタカナでご入力ください")>
    <DisplayName("名（カナ）")> _
    Public Property KANA_MEI As String

    <Required(ErrorMessage:="メールアドレスは必須項目です")> _
    <StringLength(50, ErrorMessage:="メールアドレスは50文字以内で入力してください。")>
    <RegularExpression("^[a-zA-Z_0-9]+([-+.][a-zA-Z_0-9]+)*@[a-zA-Z_0-9]+([-.][a-zA-Z_0-9]+)*\.[a-zA-Z_0-9]+([-.][a-zA-Z_0-9]+)*$", ErrorMessage:="メールアドレスの形式が正しくありません")>
    <DisplayName("メールアドレス")> _
    Public Property E_MAIL As String

    <Required(ErrorMessage:="電話番号は必須項目です")> _
    <StringLength(20, ErrorMessage:="電話番号は20文字以内で入力してください。")>
    <RegularExpression("^[0-9-]+$", ErrorMessage:="電話番号は数字と-でご入力ください")>
    <DisplayName("電話番号")> _
    Public Property TEL As String

    <Required(ErrorMessage:="電話番号（緊急連絡先）は必須項目です")> _
    <StringLength(20, ErrorMessage:="電話番号（緊急連絡先）は20文字以内で入力してください。")>
     <RegularExpression("^[0-9-]+$", ErrorMessage:="電話番号（緊急連絡先）は数字と-でご入力ください")>
    <DisplayName("電話番号（緊急連絡先）")> _
    Public Property URGENT_TEL As String

    <Required(ErrorMessage:="郵便番号は必須項目です")> _
    <RegularExpression("^[0-9]{3}[-]{1}[0-9]{4}$", ErrorMessage:="郵便番号は123-4567の形式でご入力ください")>
    <DisplayName("郵便番号")> _
    Public Property ZIP As String

    <Required(ErrorMessage:="都道府県は必須項目です")> _
    <StringLength(10, ErrorMessage:="都道府県は10文字以内で入力してください。")>
    <DisplayName("都道府県")> _
    Public Property ADDRESS1 As String

    <Required(ErrorMessage:="市区町村・番地は必須項目です")> _
    <StringLength(50, ErrorMessage:="市区町村・番地は50文字以内で入力してください。")>
    <DisplayName("市区町村・番地")> _
    Public Property ADDRESS2 As String

    <DisplayName("アパート・マンション名")> _
    <StringLength(50, ErrorMessage:="アパート・マンション名は50文字以内で入力してください。")>
    Public Property ADDRESS3 As String

End Class

Public Class EditUserPasswordModel
    <Required(ErrorMessage:="パスワードは必須項目です")> _
    <StringLength(20, ErrorMessage:="パスワードは6文字以上20文字以内で入力してください。", minimumLength:=6)>
    <RegularExpression("^[0-9a-zA-Z]*$", ErrorMessage:="パスワードは半角英数字でご入力ください")>
    <DisplayName("パスワード")> _
    Public Property PASSWORD As String

    <Required(ErrorMessage:="パスワード（確認）は必須項目です")> _
    <DisplayName("パスワード（確認）")> _
    Public Property PASSWORD2 As String

    <DisplayName("パスワード")> _
    Public Property PASSWORD_CONFIRM As String
End Class

Public Class OrdersModel
    Public Property Orders As IQueryable(Of Orders)
End Class

Public Class OrderDetailsModel
    Public Property Details As IQueryable(Of OrderDetailsObj)
End Class

Public Class OrderDetailsObj
    Public Property OrderID As Integer
    Public Property OrderNo As Integer
    Public Property ProductName As String
    Public Property Price As Decimal
    Public Property Quantity As Integer

End Class