﻿
Public Class UserController
    Inherits System.Web.Mvc.Controller

    
    Function Index() As ActionResult
        Dim acc As AccountInfo = TryCast(Session("AccountInfo"), AccountInfo)

        ' ログイン情報がなければエラー
        If acc Is Nothing Then
            Return RedirectToAction("Maintenance", "Home")
        End If
        Return View()
    End Function

    <HttpPost()>
    Function Index(ByVal collection As FormCollection) As ActionResult
        Dim acc As AccountInfo = TryCast(Session("AccountInfo"), AccountInfo)

        ' ログイン情報がなければエラー
        If acc Is Nothing Then
            Return RedirectToAction("Maintenance", "Home")
        End If

        If collection.Item("button") = "検索" Then
            Dim connStr As String = Util.GetConnectionString
            Dim dc As WebShoppingDBDataContext = New WebShoppingDBDataContext(connStr)

            Dim model As UserListModel = New UserListModel

            collection.Item("search") = collection.Item("search").Trim

            ViewData("search_value") = collection.Item("search")

            If collection.Item("search") = "" Then
                ModelState.AddModelError("", "検索条件を入力してください")
            End If

            If Not ModelState.IsValid Then
                Return View()
            End If

            model.MstUser = From t In dc.GetTable(Of MstUser)() Where t.USER_ID.Contains(collection.Item("search")) Order By t.USER_ID Ascending

            Return View(model)
        Else
            Return RedirectToAction("Maintenance", "Home")
        End If
    End Function

    Function Detail(ByVal id As String) As ActionResult
        Dim acc As AccountInfo = TryCast(Session("AccountInfo"), AccountInfo)

        ' ログイン情報がなければエラー
        If acc Is Nothing Then
            Return RedirectToAction("Maintenance", "Home")
        End If

        Dim connStr As String = Util.GetConnectionString
        Dim dc As WebShoppingDBDataContext = New WebShoppingDBDataContext(connStr)

        Dim model As UserDetailModel = New UserDetailModel

        Try
            model = (From t In dc.GetTable(Of MstUser)() Where t.USER_ID = id
                    Select New UserDetailModel With {
                        .UserID = t.USER_ID,
                        .KanjiSei = t.KANJI_SEI,
                        .KanjiMei = t.KANJI_MEI,
                        .KanaSei = t.KANA_SEI,
                        .KanaMei = t.KANA_MEI,
                        .EMail = t.E_MAIL,
                        .Tel = t.TEL,
                        .UrgentTel = t.URGENT_TEL,
                        .Zip = t.ZIP,
                        .Address1 = t.ADDRESS1,
                        .Address2 = t.ADDRESS2,
                        .Address3 = t.ADDRESS3}).First
        Catch ex As Exception
            Return RedirectToAction("Maintenance", "Home")
        End Try

        Return View(model)
    End Function

    <HttpPost()>
    Function Detail(ByVal id As String, ByVal collection As FormCollection) As ActionResult
        Return RedirectToAction("Index", "User")
    End Function

    Function Orders(ByVal id As String) As ActionResult
        ' ログイン情報を取得
        Dim acc As AccountInfo = TryCast(Session("AccountInfo"), AccountInfo)

        ' ログイン情報がなければエラー
        If acc Is Nothing Then
            Return RedirectToAction("Maintenance", "Home")
        End If

        Dim connStr As String = Util.GetConnectionString
        Dim dc As WebShoppingDBDataContext = New WebShoppingDBDataContext(connStr)

        Dim model As OrdersModel = New OrdersModel

        Try
             model.Orders = From t In dc.GetTable(Of Orders)() Where t.CUSTOMER_ID = id
        Catch ex As Exception
            Return RedirectToAction("Maintenance", "Home")
        End Try
       

        Return View(model)
    End Function

    <HttpPost()>
    Function Orders(ByVal id As String, ByVal collection As FormCollection) As ActionResult
        ' ログイン情報を取得
        Dim acc As AccountInfo = TryCast(Session("AccountInfo"), AccountInfo)

        ' ログイン情報がなければエラー
        If acc Is Nothing Then
            Return RedirectToAction("Maintenance", "Home")
        End If

        Return RedirectToAction("Index", "User")
    End Function


    Function OrderDetails(ByVal uid As String, ByVal id As Integer) As ActionResult
        ' ログイン情報を取得
        Dim acc As AccountInfo = TryCast(Session("AccountInfo"), AccountInfo)

        ' ログイン情報がなければエラー
        If acc Is Nothing Then
            Return RedirectToAction("Maintenance", "Home")
        End If

        Dim connStr As String = Util.GetConnectionString
        Dim dc As WebShoppingDBDataContext = New WebShoppingDBDataContext(connStr)

        Dim list = From t In dc.GetTable(Of Orders)() Where t.CUSTOMER_ID = uid AndAlso t.ORDER_ID = id
        ' 自分の履歴でないときはエラー画面
        If list.Count = 0 Then
            Return RedirectToAction("Maintenance", "Home")
        End If

        Dim model As OrderDetailsModel = New OrderDetailsModel

        Try
            model.Details = From t In dc.GetTable(Of OrderDetails)()
                    Where t.ORDER_ID = id Order By t.ORDER_NO Ascending
                        Select New OrderDetailsObj With {
                            .OrderID = t.ORDER_ID,
                            .OrderNo = t.ORDER_NO,
                            .ProductName = t.PRODUCT_NAME,
                            .Price = t.PRICE,
                            .Quantity = t.QUANTITY}
        Catch ex As Exception
            Return RedirectToAction("Maintenance", "Home")
        End Try

        Return View(model)
    End Function

    <HttpPost()>
    Function OrderDetails(ByVal uid As String, ByVal id As String, ByVal collection As FormCollection) As ActionResult
        ' ログイン情報を取得
        Dim acc As AccountInfo = TryCast(Session("AccountInfo"), AccountInfo)

        ' ログイン情報がなければエラー
        If acc Is Nothing Then
            Return RedirectToAction("Maintenance", "Home")
        End If

        Return RedirectToAction("Orders/" & uid, "User")
    End Function

    Function Edit(ByVal id As String) As ActionResult
        Dim acc As AccountInfo = TryCast(Session("AccountInfo"), AccountInfo)

        ' ログイン情報がなければエラー
        If acc Is Nothing Then
            Return RedirectToAction("Maintenance", "Home")
        End If

        Dim obj As EditUserModel = TryCast(Session("EditUserData"), EditUserModel)

        Dim connStr As String = Util.GetConnectionString
        Dim dc As WebShoppingDBDataContext = New WebShoppingDBDataContext(connStr)

        Dim model As EditUserModel = New EditUserModel

        If obj Is Nothing Then

            Try
                model = (From t In dc.GetTable(Of MstUser)() Where t.USER_ID = id
                            Select New EditUserModel With {
                                .OperatorID = t.USER_ID,
                                .IsLock = t.IS_LOCK,
                                .Deleted = t.DELETED}).First
            Catch ex As Exception
                Return RedirectToAction("Maintenance", "Home")
            End Try
        Else
            Try
                model = (From t In dc.GetTable(Of MstUser)() Where t.USER_ID = id
                            Select New EditUserModel With {
                                .OperatorID = t.USER_ID,
                                .IsLock = t.IS_LOCK,
                                .Deleted = t.DELETED}).First
            Catch ex As Exception
                Return RedirectToAction("Maintenance", "Home")
            End Try

            model = obj
        End If

        Return View(model)
    End Function

    <HttpPost()>
    Function Edit(ByVal id As String, ByVal model As EditUserModel, ByVal collection As FormCollection) As ActionResult
        Dim acc As AccountInfo = TryCast(Session("AccountInfo"), AccountInfo)

        ' ログイン情報がなければエラー
        If acc Is Nothing Then
            Return RedirectToAction("Maintenance", "Home")
        End If

        If collection.Item("button") = "戻る" Then
            Return RedirectToAction("Index", "User")
        ElseIf collection.Item("button") = "確認" Then

            model.OperatorID = id
            Session("EditUserData") = model
            Return RedirectToAction("EditConfirm", "User")

        Else
            Return RedirectToAction("Maintenance", "Home")
        End If
    End Function

    Function EditConfirm() As ActionResult
        Dim acc As AccountInfo = TryCast(Session("AccountInfo"), AccountInfo)

        ' ログイン情報がなければエラー
        If acc Is Nothing Then
            Return RedirectToAction("Maintenance", "Home")
        End If

        Dim obj As EditUserModel = TryCast(Session("EditUserData"), EditUserModel)

        If obj Is Nothing Then
            Return RedirectToAction("Maintenance", "Home")
        End If

        Return View(obj)
    End Function

    <HttpPost()>
    Function EditConfirm(ByVal collection As FormCollection) As ActionResult
        Dim acc As AccountInfo = TryCast(Session("AccountInfo"), AccountInfo)

        ' ログイン情報がなければエラー
        If acc Is Nothing Then
            Return RedirectToAction("Maintenance", "Home")
        End If

        Dim obj As EditUserModel = TryCast(Session("EditUserData"), EditUserModel)

        If obj Is Nothing Then
            Return RedirectToAction("Maintenance", "Home")
        End If

        If collection.Item("button") = "戻る" Then
            Return RedirectToAction("Edit/" & obj.OperatorID, "User")
        ElseIf collection.Item("button") = "保存" Then
            Dim connStr As String = Util.GetConnectionString
            Dim dc As WebShoppingDBDataContext = New WebShoppingDBDataContext(connStr)

            ' ユーザマスタの更新
            Try
                dc.updateUserMst2(obj.OperatorID, obj.IsLock, obj.Deleted)
                dc.SubmitChanges()
            Catch ex As Exception
                Return RedirectToAction("Maintenance", "Home")
            End Try
            ' セッションのクリア
            Session("EditUserData") = Nothing

            ' メッセージボックスの表示
            Session("MessageBoxTitle") = "ユーザ情報更新完了"
            Session("MessageBoxMessage") = "ユーザのロック・削除情報の更新が完了しました"
            Return RedirectToAction("MessageBox", "Home")
        Else
            Return RedirectToAction("Maintenance", "Home")
        End If
    End Function

    Function PasswordChange(ByVal id As String) As ActionResult
        Dim acc As AccountInfo = TryCast(Session("AccountInfo"), AccountInfo)

        ' ログイン情報がなければエラー
        If acc Is Nothing Then
            Return RedirectToAction("Maintenance", "Home")
        End If

        Dim obj As PasswordUserModel = TryCast(Session("PasswordUserData"), PasswordUserModel)

        Dim connStr As String = Util.GetConnectionString
        Dim dc As WebShoppingDBDataContext = New WebShoppingDBDataContext(connStr)

        Dim model As PasswordUserModel = New PasswordUserModel

        If obj Is Nothing Then

            Try
                model = (From t In dc.GetTable(Of MstUser)() Where t.USER_ID = id
                            Select New PasswordUserModel With {
                                .OperatorID = t.USER_ID}).First
            Catch ex As Exception
                Return RedirectToAction("Maintenance", "Home")
            End Try
        Else
            Try
                model = (From t In dc.GetTable(Of MstUser)() Where t.USER_ID = id
                            Select New PasswordUserModel With {
                                .OperatorID = t.USER_ID}).First
            Catch ex As Exception
                Return RedirectToAction("Maintenance", "Home")
            End Try

            model = obj
        End If

        Return View(model)
    End Function

    <HttpPost()>
    Function PasswordChange(ByVal id As String, ByVal model As PasswordUserModel, ByVal collection As FormCollection) As ActionResult
        Dim acc As AccountInfo = TryCast(Session("AccountInfo"), AccountInfo)

        ' ログイン情報がなければエラー
        If acc Is Nothing Then
            Return RedirectToAction("Maintenance", "Home")
        End If

        If collection.Item("button") = "戻る" Then
            Return RedirectToAction("Index", "User")
        ElseIf collection.Item("button") = "確認" Then

            ' 追加のバリデーション

            ' パスワード
            If Util.NStr(model.Password) <> Util.NStr(model.Password2) Then
                ModelState.AddModelError("PASSWORD2", "パスワードとパスワード（確認）が一致しません。")
            End If

            model.OperatorID = id

            If ModelState.IsValid Then
                Session("PasswordUserData") = model
                Return RedirectToAction("PasswordChangeConfirm", "User")
            End If

            Return View(model)
        Else
            Return RedirectToAction("Maintenance", "Home")
        End If
    End Function

    Function PasswordChangeConfirm() As ActionResult
        Dim acc As AccountInfo = TryCast(Session("AccountInfo"), AccountInfo)

        ' ログイン情報がなければエラー
        If acc Is Nothing Then
            Return RedirectToAction("Maintenance", "Home")
        End If

        Dim obj As PasswordUserModel = TryCast(Session("PasswordUserData"), PasswordUserModel)

        If obj Is Nothing Then
            Return RedirectToAction("Maintenance", "Home")
        End If

        obj.PasswordConfirm = Util.GetMaskString(obj.Password)

        Return View(obj)
    End Function

    <HttpPost()>
    Function PasswordChangeConfirm(ByVal collection As FormCollection) As ActionResult
        Dim acc As AccountInfo = TryCast(Session("AccountInfo"), AccountInfo)

        ' ログイン情報がなければエラー
        If acc Is Nothing Then
            Return RedirectToAction("Maintenance", "Home")
        End If

        Dim obj As PasswordUserModel = TryCast(Session("PasswordUserData"), PasswordUserModel)

        If obj Is Nothing Then
            Return RedirectToAction("Maintenance", "Home")
        End If


        If collection.Item("button") = "戻る" Then
            Return RedirectToAction("PasswordChange/" & obj.OperatorID, "User")
        ElseIf collection.Item("button") = "保存" Then
            Dim connStr As String = Util.GetConnectionString
            Dim dc As WebShoppingDBDataContext = New WebShoppingDBDataContext(connStr)

            Dim encryptedPassword As String = Crypt.EncryptSHA256(obj.Password)

            ' オペレータマスタの更新
            Try
                dc.updateUserPassword(obj.OperatorID, encryptedPassword)
                dc.SubmitChanges()
            Catch ex As Exception
                Return RedirectToAction("Maintenance", "Home")
            End Try
            ' セッションのクリア
            Session("PasswordUserData") = Nothing

            ' メッセージボックスの表示
            Session("MessageBoxTitle") = "ユーザパスワード更新完了"
            Session("MessageBoxMessage") = "ユーザのパスワードの更新が完了しました"
            Return RedirectToAction("MessageBox", "Home")
        Else
            Return RedirectToAction("Maintenance", "Home")
        End If
    End Function
End Class
