﻿Imports System.ComponentModel
Imports System.ComponentModel.DataAnnotations
Imports System.Globalization

Public Class OperatorListModel
    Public Property MstOperator As IQueryable(Of MstOperator)
End Class

Public Class CreateOperatorModel

    <Required(ErrorMessage:="オペレータIDは必須項目です")> _
   <StringLength(20, ErrorMessage:="オペレータIDは20文字以内で入力してください。")>
   <RegularExpression("^[0-9a-zA-Z]*$", ErrorMessage:="オペレータIDは半角英数字でご入力ください")>
   <DisplayName("オペレータID")> _
    Public Property OperatorID As String

    <Required(ErrorMessage:="オペレータ名は必須項目です")> _
    <StringLength(20, ErrorMessage:="オペレータ名は20文字以内で入力してください。")>
    <DisplayName("オペレータ名")> _
    Public Property OperatorName As String

    <Required(ErrorMessage:="パスワードは必須項目です")> _
   <StringLength(20, ErrorMessage:="パスワードは6文字以上20文字以内で入力してください。", minimumLength:=6)>
   <DisplayName("パスワード")> _
    Public Property Password As String

    <Required(ErrorMessage:="パスワード（確認）は必須項目です")> _
    <DisplayName("パスワード（確認）")> _
    Public Property Password2 As String

    <DisplayName("パスワード")> _
    Public Property PasswordConfirm As String
End Class

Public Class EditOperatorModel
    <DisplayName("オペレータID")> _
    Public Property OperatorID As String

    <Required(ErrorMessage:="オペレータ名は必須項目です")> _
   <StringLength(20, ErrorMessage:="オペレータ名は20文字以内で入力してください。")>
   <DisplayName("オペレータ名")> _
    Public Property OperatorName As String

    <DisplayName("ロック")> _
    Public Property IsLock As Boolean

    <DisplayName("削除")> _
    Public Property Deleted As Boolean

End Class

Public Class PasswordOperatorModel
    <DisplayName("オペレータID")> _
    Public Property OperatorID As String

    <Required(ErrorMessage:="パスワードは必須項目です")> _
    <StringLength(20, ErrorMessage:="パスワードは6文字以上20文字以内で入力してください。", minimumLength:=6)>
    <DisplayName("パスワード")> _
    Public Property Password As String

    <Required(ErrorMessage:="パスワード（確認）は必須項目です")> _
    <DisplayName("パスワード（確認）")> _
    Public Property Password2 As String

    <DisplayName("パスワード")> _
    Public Property PasswordConfirm As String
End Class
