﻿Imports System.ComponentModel
Imports System.ComponentModel.DataAnnotations
Imports System.Globalization

Public Class CategoryListModel
    Public Property Category As IQueryable(Of Categories)
End Class

Public Class CategoryModel

    <DisplayName("カテゴリID")> _
    Public Property CategoryID As Integer

    <Required(ErrorMessage:="カテゴリ名は必須項目です")> _
    <StringLength(20, ErrorMessage:="カテゴリ名は20文字以内で入力してください。")>
    <DisplayName("カテゴリ名")> _
    Public Property CategoryName As String

    <Required(ErrorMessage:="SortNoは必須項目です")> _
     <StringLength(4, ErrorMessage:="Sort Noは4文字以内で入力してください。")>
     <RegularExpression("^[0-9]*$", ErrorMessage:="Sort Noは数字でご入力ください")>
    <DisplayName("Sort No")> _
    Public Property SortNo As String

End Class


Public Class ProductListModel
    Public Property Product As IQueryable(Of Products)
End Class

Public Class ProductModel

    <DisplayName("商品ID")> _
    Public Property ProductID As Integer

    <Required(ErrorMessage:="商品名は必須項目です")> _
    <StringLength(100, ErrorMessage:="商品名は100文字以内で入力してください。")>
    <DisplayName("商品名")> _
    Public Property ProductName As String

    <Required(ErrorMessage:="商品詳細は必須項目です")> _
    <StringLength(1024, ErrorMessage:="商品詳細は1024文字以内で入力してください。")>
    <DisplayName("商品詳細")> _
    Public Property ProductDescription As String

    <DisplayName("カテゴリ")> _
    Public Property CategoryID As Integer

    <DisplayName("カテゴリ")> _
    Public Property CategoryName As String

    <Required(ErrorMessage:="価格は必須項目です")> _
    <StringLength(10, ErrorMessage:="価格は10桁以内で入力してください。")>
    <RegularExpression("^[0-9]*$", ErrorMessage:="価格は数字でご入力ください")>
   <DisplayName("価格")> _
    Public Property Price As String

    <Required(ErrorMessage:="SortNoは必須項目です")> _
     <StringLength(4, ErrorMessage:="Sort Noは4文字以内で入力してください。")>
     <RegularExpression("^[0-9]*$", ErrorMessage:="Sort Noは数字でご入力ください")>
    <DisplayName("Sort No")> _
    Public Property SortNo As String

End Class