﻿Imports System.ComponentModel
Imports System.ComponentModel.DataAnnotations
Imports System.Globalization

Public Class UserListModel
    Public Property MstUser As IQueryable(Of MstUser)
End Class

Public Class UserDetailModel
    <DisplayName("ユーザID")> _
    Public Property UserID As String
    <DisplayName("姓（漢字）")> _
    Public Property KanjiSei As String
    <DisplayName("名（漢字）")>
    Public Property KanjiMei As String
    <DisplayName("姓（カナ）")>
    Public Property KanaSei As String
    <DisplayName("名（カナ）")>
    Public Property KanaMei As String
    <DisplayName("メールアドレス")>
    Public Property EMail As String
    <DisplayName("電話番号")>
    Public Property Tel As String
    <DisplayName("電話番号（緊急連絡先）")>
    Public Property UrgentTel As String
    <DisplayName("郵便番号")>
    Public Property Zip As String
    <DisplayName("都道府県")>
    Public Property Address1 As String
    <DisplayName("市区町村・番地")>
    Public Property Address2 As String
    <DisplayName("アパート・マンション名")>
    Public Property Address3 As String
End Class

Public Class OrdersModel
    Public Property Orders As IQueryable(Of Orders)
End Class

Public Class OrderDetailsModel
    Public Property Details As IQueryable(Of OrderDetailsObj)
End Class

Public Class OrderDetailsObj
    Public Property OrderID As Integer
    Public Property OrderNo As Integer
    Public Property ProductName As String
    Public Property Price As Decimal
    Public Property Quantity As Integer

End Class

Public Class EditUserModel
    <DisplayName("オペレータID")> _
    Public Property OperatorID As String

    <DisplayName("ロック")> _
    Public Property IsLock As Boolean

    <DisplayName("削除")> _
    Public Property Deleted As Boolean

End Class

Public Class PasswordUserModel
    <DisplayName("オペレータID")> _
    Public Property OperatorID As String

    <Required(ErrorMessage:="パスワードは必須項目です")> _
    <StringLength(20, ErrorMessage:="パスワードは6文字以上20文字以内で入力してください。", minimumLength:=6)>
    <RegularExpression("^[0-9a-zA-Z]*$", ErrorMessage:="パスワードは半角英数字でご入力ください")>
    <DisplayName("パスワード")> _
    Public Property Password As String

    <Required(ErrorMessage:="パスワード（確認）は必須項目です")> _
    <DisplayName("パスワード（確認）")> _
    Public Property Password2 As String

    <DisplayName("パスワード")> _
    Public Property PasswordConfirm As String
End Class